(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



BeginPackage["Lautrup`General`"];

(* first unprotect all symbols in this context *)
Unprotect["`*"];

(* messages *)
HoldSubscripts::usage = "HoldSubscripts[] makes subscripted heads work as a single symbol";
ReleaseSubscripts::usage = "ReleaseSubscripts[] make subscripted heads work as in standard Mathematica";

DoCollect::usage="DoCollect[args][exp] works as Collect[exp,args]";
DoSeries::usage="DoSeries[args][exp] works as Series[exp,args]";
DoLimit::usage="DoLimit[args][exp] works as Limit[exp,args]";

Begin["`Private`"];

(* permit input powers of derivatives *)
MakeExpression[RowBox[{SuperscriptBox[SubscriptBox ["\[PartialD]", x_], n_], f_}], StandardForm] :=
 HoldComplete[D[ToExpression[f], {ToExpression[x], ToExpression[n]}]]

(* hold and release subscripts; alternative way *)
HoldSubscripts[] := Block[{},SetSystemOptions["DifferentiationOptions"->{"DifferentiateHeads"->False}];SetAttributes[Subscript, {Constant,HoldAllComplete}]]
ReleaseSubscripts[] := Block[{},SetSystemOptions["DifferentiationOptions"->{"DifferentiateHeads"->True}];ClearAttributes[Subscript, {Constant,HoldAllComplete}]]

(* convenience functions *)
DoCollect[args__][exp_] := Collect[exp, args]
DoSeries[args__][exp_] := Series[exp, args]
DoLimit[args__][exp_] := Limit[exp, args]
End[];

SetAttributes[Evaluate[Names["`*"]], {Protected, ReadProtected}];
EndPackage[]

(* initialize *)
HoldSubscripts[]; 




