(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     14968,        331]
NotebookOptionsPosition[     13866,        288]
NotebookOutlinePosition[     14491,        312]
CellTagsIndexPosition[     14406,        307]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["EmbedAllFonts usage", "Title",
 CellChangeTimes->{{3.5051153700470147`*^9, 3.505115379421551*^9}, {
  3.505119166295148*^9, 3.5051191688222923`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "EmbedAllFonts"}]], "Input",
 CellChangeTimes->{{3.5051155302891803`*^9, 3.505115535296467*^9}}],

Cell[BoxData[
 StyleBox["\<\"EmbedAllFonts[in, out] embeds all fonts used in the pdf-file \
'in' and places the result in the pdf-file 'out'\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.5707779939573812`*^9},
 CellTags->"Info3570781593-3584394"]
}, Open  ]],

Cell["This program is normally called from Lautrup`Figure`", "Text",
 CellChangeTimes->{{3.505119238486277*^9, 3.505119258375415*^9}, {
  3.5052939745276413`*^9, 3.5052939786218753`*^9}}],

Cell[CellGroupData[{

Cell["Options", "Subsection",
 CellChangeTimes->{{3.5051155989191055`*^9, 3.505115608454651*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "EmbedAllFonts", "]"}]], "Input",
 CellChangeTimes->{{3.50511561542505*^9, 3.505115620712352*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "PDFtoPDF", 
   "\[Rule]", "\<\"C:\\\\Users\\\\Benny\\\\Documents\\\\My Dropbox\\\\LAUTRUP\
\\\\Mathematica\\\\Lautrup\\\\pdftopdf\\\\pdftopdf.bat\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.5051156216024027`*^9, 3.5051156503190455`*^9}, {
   3.506494691724206*^9, 3.506494702688833*^9}, 3.570774965989977*^9, 
   3.5707777964574537`*^9, {3.5707778758035517`*^9, 3.5707778960060244`*^9}, 
   3.5707779268619723`*^9, 3.5707779939994273`*^9}]
}, Open  ]],

Cell["This option specifies where the pdftopdf script is found.", "Text",
 CellChangeTimes->{{3.505115669003114*^9, 3.505115716118809*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["EmbedAllFonts package", "Title",
 CellChangeTimes->{{3.505115363030614*^9, 3.5051153660617867`*^9}, {
  3.5051191724384995`*^9, 3.5051191771117663`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"BeginPackage", "[", "\"\<Lautrup`EmbedAllFonts`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ClearAttributes", "[", 
  RowBox[{"EmbedAllFonts", ",", 
   RowBox[{"{", 
    RowBox[{"Protected", ",", "ReadProtected"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"EmbedAllFonts", "::", "\"\<usage\>\""}], "=", 
   "\"\<EmbedAllFonts[in, out] embeds all fonts used in the pdf-file 'in' and \
places the result in the pdf-file 'out'\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"EmbedAllFonts", "::", "\"\<noembed\>\""}], "=", 
   "\"\<Unable to embed fonts\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"EmbedAllFonts", "::", "\"\<embed\>\""}], "=", 
    "\"\<All fonts embedded\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"EmbedAllFonts", "[", 
   RowBox[{"input_String", ",", "output_String", ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"!", 
       RowBox[{"FileExistsQ", "[", "input", "]"}]}], ",", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"General", "::", "\"\<noopen\>\""}], ",", "input"}], "]"}], 
       ";", 
       RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"FileExtension", "[", "input", "]"}], "!=", "\"\<pdf\>\""}], "||", 
       RowBox[{
        RowBox[{"FileExtension", "[", "output", "]"}], "!=", 
        "\"\<pdf\>\""}]}], ",", 
      RowBox[{"Return", "[", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"program", "=", 
     RowBox[{"OptionValue", "[", "PDFtoPDF", "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"!", 
        RowBox[{"FileExistsQ", "[", "program", "]"}]}], "||", 
       RowBox[{"DirectoryQ", "[", "program", "]"}]}], ",", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"General", "::", "\"\<noopen\>\""}], ",", "program"}], "]"}],
        ";", 
       RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Run", "[", 
        RowBox[{"program", ",", "input", ",", "output", ",", 
         RowBox[{"DirectoryName", "[", "program", "]"}]}], "]"}], " ", "!=", 
       "0"}], ",", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"EmbedAllFonts", "::", "\"\<noembed\>\""}], "]"}], ";", 
       RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Message", "[", 
     RowBox[{"EmbedAllFonts", "::", "\"\<embed\>\""}], "]"}], ";", 
    RowBox[{"Return", "[", "]"}]}], ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "EmbedAllFonts", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"PDFtoPDF", "\[Rule]", 
     RowBox[{"FileNameJoin", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"DirectoryName", "[", 
         RowBox[{"FindFile", "[", "\"\<Lautrup`\>\"", "]"}], "]"}], ",", 
        "\"\<pdftopdf\>\"", ",", "\"\<pdftopdf.bat\>\""}], "}"}], "]"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"EmbedAllFonts", ",", 
    RowBox[{"{", 
     RowBox[{"Protected", ",", "ReadProtected"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EndPackage", "[", "]"}], " "}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4763358173780184`*^9, 3.4763358509139366`*^9}, {
   3.4763358937603874`*^9, 3.476335896184526*^9}, {3.476335930765504*^9, 
   3.4763359757790785`*^9}, {3.476336017346456*^9, 3.476336035266481*^9}, {
   3.476336072868632*^9, 3.4763361008372316`*^9}, 3.4763361338621206`*^9, {
   3.4763365057803926`*^9, 3.4763365860429835`*^9}, {3.476336704533761*^9, 
   3.4763367417568903`*^9}, {3.4763374615480595`*^9, 
   3.4763374666433516`*^9}, {3.476337578277736*^9, 3.4763376982846003`*^9}, {
   3.4763382781247654`*^9, 3.476338279361836*^9}, 3.4763387302476254`*^9, {
   3.4763388142044272`*^9, 3.4763388454132123`*^9}, {3.4763389199884777`*^9, 
   3.476339065891823*^9}, {3.4763391963882866`*^9, 3.4763392417538815`*^9}, 
   3.4763398300155287`*^9, 3.4763405585061955`*^9, {3.4763407050055747`*^9, 
   3.4763407061736417`*^9}, {3.476340770942346*^9, 3.4763407727104473`*^9}, {
   3.4763408684519234`*^9, 3.4763408698060007`*^9}, {3.4763435745547037`*^9, 
   3.476343606937556*^9}, {3.476345224154055*^9, 3.4763452933490133`*^9}, 
   3.476345889069086*^9, 3.4763460553485966`*^9, {3.476346483344077*^9, 
   3.476346485194183*^9}, {3.4763465283576517`*^9, 3.4763465848458824`*^9}, {
   3.47634684599782*^9, 3.4763469371090307`*^9}, {3.4763471174253445`*^9, 
   3.476347133554267*^9}, {3.4763472303008003`*^9, 3.4763472310068407`*^9}, {
   3.4763484396319704`*^9, 3.476348516637375*^9}, {3.476348808781084*^9, 
   3.4763488196267047`*^9}, {3.4763489350633073`*^9, 
   3.4763489573425817`*^9}, {3.4763489930376234`*^9, 3.476349001800124*^9}, 
   3.4763490550191684`*^9, {3.4763492831202145`*^9, 3.476349321780426*^9}, {
   3.4763493802237687`*^9, 3.4763495019767327`*^9}, {3.476349615292214*^9, 
   3.4763496220506005`*^9}, {3.4763502726138105`*^9, 3.47635029497209*^9}, {
   3.476350381156019*^9, 3.4763503961948795`*^9}, {3.4763505296995153`*^9, 
   3.4763505685687385`*^9}, {3.476350608275009*^9, 3.476350682845275*^9}, {
   3.4763507195413733`*^9, 3.476350747569977*^9}, {3.4763508093715115`*^9, 
   3.476350810443573*^9}, {3.476350981755371*^9, 3.476351062950015*^9}, {
   3.4763512832396154`*^9, 3.476351367054409*^9}, {3.4763688491872263`*^9, 
   3.476368876110766*^9}, {3.4763690700958614`*^9, 3.4763691159764853`*^9}, {
   3.4763691687025013`*^9, 3.476369178346053*^9}, 3.476369255259452*^9, {
   3.4763692988839474`*^9, 3.4763693308307743`*^9}, 3.4763699270748777`*^9, {
   3.476370986339464*^9, 3.476371193434309*^9}, {3.476371228361307*^9, 
   3.476371233639609*^9}, {3.4763713157803073`*^9, 3.4763713166673574`*^9}, {
   3.4763714006921635`*^9, 3.4763714016852207`*^9}, 3.476782956363719*^9, {
   3.476783058968588*^9, 3.476783061354724*^9}, {3.476783288187698*^9, 
   3.476783288907739*^9}, {3.4767833544994907`*^9, 3.4767833551235266`*^9}, {
   3.476783417461092*^9, 3.4767834532761407`*^9}, 3.4767835025399585`*^9, {
   3.476783535004815*^9, 3.476783535491843*^9}, {3.476783566476615*^9, 
   3.4767835710838785`*^9}, {3.476783834891968*^9, 3.4767838686849003`*^9}, {
   3.476784022132677*^9, 3.476784026923951*^9}, {3.4767840827891464`*^9, 
   3.476784084364237*^9}, {3.4767841178771534`*^9, 3.4767841669479604`*^9}, {
   3.4767841994288177`*^9, 3.4767842480535994`*^9}, 3.4767843238929367`*^9, {
   3.4767843604360275`*^9, 3.476784364948285*^9}, {3.4767844459179163`*^9, 
   3.476784501468094*^9}, 3.4767845334929256`*^9, 3.479898622909*^9, {
   3.47989868563*^9, 3.479898767258*^9}, {3.479898857676*^9, 
   3.479898890351*^9}, {3.479898930975*^9, 3.479898960875*^9}, {
   3.479899123918*^9, 3.479899140269*^9}, {3.479899799727*^9, 
   3.479899841198*^9}, 3.479899877759*^9, {3.479900318285*^9, 
   3.4799003956610003`*^9}, {3.479900476639*^9, 3.4799004816619997`*^9}, {
   3.4799005796940002`*^9, 3.479900610525*^9}, {3.479900652462*^9, 
   3.479900652541*^9}, {3.4799007792799997`*^9, 3.479900829885*^9}, {
   3.4799008755179996`*^9, 3.479900902318*^9}, {3.479967241903*^9, 
   3.4799673518719997`*^9}, {3.4799673862460003`*^9, 3.479967390783*^9}, 
   3.479967586882*^9, {3.480493486519*^9, 3.480493543223*^9}, {
   3.504942284439042*^9, 3.504942351231862*^9}, {3.5049425982379904`*^9, 
   3.504942605077381*^9}, {3.504942654253194*^9, 3.5049426594374905`*^9}, {
   3.5049426948865185`*^9, 3.5049427215190415`*^9}, {3.504942778000272*^9, 
   3.5049428376226826`*^9}, {3.504942876664915*^9, 3.5049429326801195`*^9}, {
   3.5049446587568455`*^9, 3.5049446697084713`*^9}, {3.5049447027833633`*^9, 
   3.5049449466713133`*^9}, {3.504945002336497*^9, 3.5049450043446116`*^9}, {
   3.504945098184979*^9, 3.5049451337680144`*^9}, {3.504945209623353*^9, 
   3.504945296912346*^9}, {3.50494535171348*^9, 3.504945360407977*^9}, {
   3.504945427208798*^9, 3.504945432105078*^9}, {3.5049454741914854`*^9, 
   3.5049454767036295`*^9}, {3.5049455432224336`*^9, 3.504945590601144*^9}, {
   3.504945628282299*^9, 3.504945643673179*^9}, 3.5049458083385973`*^9, {
   3.504945839730393*^9, 3.5049459297115393`*^9}, {3.5049460137333455`*^9, 
   3.50494602412594*^9}, 3.504946691083088*^9, {3.504946898916975*^9, 
   3.504946902371173*^9}, {3.5049469454526367`*^9, 3.504946960613504*^9}, {
   3.504947001212826*^9, 3.504947249285015*^9}, {3.504948205341698*^9, 
   3.504948240636717*^9}, 3.5049482775348277`*^9, {3.50494889736828*^9, 
   3.5049489091109514`*^9}, {3.504948947583152*^9, 3.504948974855712*^9}, {
   3.5049490412965117`*^9, 3.5049490460157824`*^9}, {3.50494967363968*^9, 
   3.5049496915127025`*^9}, {3.5049545844715633`*^9, 3.5049546126231737`*^9}, 
   3.504954669110405*^9, {3.504955155300213*^9, 3.504955169918049*^9}, {
   3.5049552081422358`*^9, 3.504955215663666*^9}, 3.504957923622552*^9, {
   3.5049579573824835`*^9, 3.504958022612214*^9}, {3.5049587896220846`*^9, 
   3.5049587953574123`*^9}, {3.5049589878724236`*^9, 3.504959050548009*^9}, 
   3.504959937357731*^9, {3.504960403410388*^9, 3.5049604071486015`*^9}, {
   3.506493295573351*^9, 3.5064933384078007`*^9}, {3.506493374048839*^9, 
   3.5064933826933336`*^9}, {3.5064934321331615`*^9, 3.506493438872547*^9}, {
   3.5064934823440332`*^9, 3.506493513385809*^9}, {3.5064935880580797`*^9, 
   3.506493665422505*^9}, {3.5064937915977216`*^9, 3.506493818796277*^9}, {
   3.506493859380598*^9, 3.5064938620597515`*^9}, {3.5064938952206483`*^9, 
   3.5064939001719313`*^9}, {3.506494019709769*^9, 3.506494107453788*^9}, {
   3.5064946699369593`*^9, 3.50649471347445*^9}, {3.5064949137639055`*^9, 
   3.5064949491849318`*^9}, {3.5064951070929637`*^9, 3.506495109246087*^9}, {
   3.506495164847267*^9, 3.506495166091338*^9}, {3.5064952350792837`*^9, 
   3.506495244958849*^9}, {3.506495300936051*^9, 3.506495302134119*^9}, {
   3.5064953448875647`*^9, 3.506495362606578*^9}, {3.5064954137505035`*^9, 
   3.5064954465823812`*^9}, {3.5064954937350783`*^9, 3.506495533543355*^9}, {
   3.5064955795099845`*^9, 3.506495594891864*^9}, {3.5064960362531085`*^9, 
   3.506496052583042*^9}, {3.5064962005335045`*^9, 3.506496200990531*^9}, 
   3.506496242493905*^9, 3.5064963677030663`*^9, {3.5064965602480793`*^9, 
   3.5064965631662464`*^9}, {3.506496628064958*^9, 3.5064966300460715`*^9}, {
   3.506496901087574*^9, 3.506496990810706*^9}, {3.5064970439057426`*^9, 
   3.5064970527772503`*^9}, 3.5064971325858154`*^9, {3.506497272953844*^9, 
   3.5064973209635897`*^9}, {3.5064973760017376`*^9, 3.506497385680291*^9}, {
   3.5064974213633327`*^9, 3.506497455643293*^9}, {3.5707749433301177`*^9, 
   3.570774947705626*^9}, {3.570775071027219*^9, 3.5707750719033127`*^9}, {
   3.570777845409605*^9, 3.570777850016246*^9}, {3.570777969945335*^9, 
   3.5707779787774506`*^9}}]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{710, 750},
WindowMargins->{{Automatic, 508}, {Automatic, 21}},
ShowSelection->True,
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->FrontEnd`FileName[{"Creative"}, "PastelColor.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3570781593-3584394"->{
  Cell[874, 32, 261, 5, 40, "Print",
   CellTags->"Info3570781593-3584394"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3570781593-3584394", 14305, 301}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 155, 2, 65, "Title"],
Cell[CellGroupData[{
Cell[747, 28, 124, 2, 41, "Input"],
Cell[874, 32, 261, 5, 40, "Print",
 CellTags->"Info3570781593-3584394"]
}, Open  ]],
Cell[1150, 40, 187, 2, 30, "Text"],
Cell[CellGroupData[{
Cell[1362, 46, 97, 1, 36, "Subsection"],
Cell[CellGroupData[{
Cell[1484, 51, 137, 2, 41, "Input"],
Cell[1624, 55, 489, 10, 62, "Output"]
}, Open  ]],
Cell[2128, 68, 139, 1, 30, "Text"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2316, 75, 159, 2, 65, "Title"],
Cell[2478, 79, 11372, 206, 542, "Input",
 InitializationCell->True]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
